#ifndef SOUNDS
    #define SOUNDS
    #include "sounds.h"
#endif

#include "Creditos.h"

class Abertura {
public:
BITMAP *abertura_fundo;
BITMAP *slugAtirando;
BITMAP *slugAndando_dir;
BITMAP *slugAndando_esq;
BITMAP *slugParado;
BITMAP *ajuda;
Creditos *credito;


    Abertura() {
        abertura_fundo = load_bitmap("images\\abertura2.bmp",NULL);
        slugAtirando = load_bitmap("images\\Slug_Atirando_Pistola1.bmp",NULL);
        slugAndando_dir = load_bitmap("images\\Slug_Andando_Pistola1.bmp", NULL);
        slugAndando_esq = create_bitmap(slugAndando_dir->w,slugAndando_dir->h);
        slugParado = load_bitmap("images\\Parado.bmp", NULL);
        ajuda = load_bitmap("images\\Ajuda2.bmp", NULL);
		credito = new Creditos();
    }
    ~Abertura() {
        destroy_bitmap(abertura_fundo);
        destroy_bitmap(slugAtirando);
        destroy_bitmap(slugAndando_dir);
        destroy_bitmap(slugAndando_esq);
        destroy_bitmap(slugParado);
        destroy_bitmap(ajuda);
    }    

int exibir() {
SAMPLE *som_tiro = load_sample(tiro);  
SAMPLE *som_fundo = load_sample(fundo); 
 

clear_to_color(this->slugAndando_esq, PIXEL_TRANSP); 
draw_sprite_h_flip(this->slugAndando_esq,this->slugAndando_dir,0,0);
int opcaoX = 10;
bool start = false;
int tamanho = this->slugAtirando->w / 10;
int altura = this->slugAtirando->h;
int tamanho_andar = this->slugAndando_dir->w / 16;
int altura_andar = this->slugAndando_dir->h;
int tamanho_parado = this->slugParado->w / 5;
int altura_parado = this->slugParado->h;
int indice = 0;

    play_sample(som_fundo, 100, 128, 1000, 1);
while(!start){
    blit(this->abertura_fundo,buffer, 0, 0, 0, 0, MAX_X, MAX_Y);
    masked_blit(this->slugParado, buffer, indice*tamanho_parado, 0, opcaoX, 180, tamanho_parado, altura_parado);
    blit(buffer, screen, 0, 0, 0, 0, buffer->w, buffer->h);
    
    if (indice < 4) {
        indice = indice + 1;
    } else {
        indice = 0;
    }
    
    if (key[KEY_RIGHT]) {
        int x_temp = opcaoX;
        int apontador = 0;
        if (opcaoX < 210) {
            for (int i = 0; i < 20; i = i + 1) {
                blit(this->abertura_fundo,buffer, 0, 0, 0, 0, MAX_X, MAX_Y);
                masked_blit(this->slugAndando_dir,buffer, apontador * tamanho_andar, 0, x_temp, 180, tamanho_andar, altura_andar);
                blit(buffer, screen, 0, 0, 0, 0, buffer->w, buffer->h);
                x_temp = x_temp + 5;
                if (apontador < 15) {
                    apontador = apontador + 1;
                } else {
                    apontador = 4;
                }    
                rest(30);
            }
        }    
        
        opcaoX = opcaoX + 100;
        if (opcaoX > 210) {
            opcaoX = 210;
        }
        blit(this->abertura_fundo,buffer, 0, 0, 0, 0, MAX_X, MAX_Y);
        masked_blit(this->slugAtirando, buffer, 0, 0, opcaoX, 180, tamanho, altura);
        blit(buffer, screen, 0, 0, 0, 0, buffer->w, buffer->h);
        rest(100);
    } else if (key[KEY_LEFT]) {
        int x_temp = opcaoX;
        int apontador = 0;
        if (opcaoX > 10) {
            for (int i = 0; i < 20; i = i + 1) {
                blit(this->abertura_fundo,buffer, 0, 0, 0, 0, MAX_X, MAX_Y);
                masked_blit(this->slugAndando_esq,buffer, apontador * tamanho_andar, 0, x_temp, 180, tamanho_andar, altura_andar);
                blit(buffer, screen, 0, 0, 0, 0, buffer->w, buffer->h);
                x_temp = x_temp - 5;
                if (apontador < 15) {
                    apontador = apontador + 1;
                } else {
                    apontador = 4;
                }    
                rest(30);
            }
        }    
        opcaoX = opcaoX - 100;
        if (opcaoX < 10) {
            opcaoX = 10;
        }    
        blit(this->abertura_fundo,buffer, 0, 0, 0, 0, MAX_X, MAX_Y);
        masked_blit(this->slugAtirando, buffer, 0, 0, opcaoX, 180, tamanho, altura);
        blit(buffer, screen, 0, 0, 0, 0, buffer->w, buffer->h);
        rest(100);
    }
    
    if (key[KEY_ENTER]) {
        play_sample(som_tiro, 200, 128, 1000, 0);
        for (int i = 0; i < 10; i = i + 1) {
            blit(this->abertura_fundo,buffer, 0, 0, 0, 0, MAX_X, MAX_Y);
            masked_blit(this->slugAtirando,buffer, i * tamanho, 0, opcaoX, 180, tamanho, altura);
            blit(buffer, screen, 0, 0, 0, 0, buffer->w, buffer->h);
            rest(20);
        }
        
        if (opcaoX == 10) {
            start = true;
            rest(30);
        } else if (opcaoX == 110) {
           while(!key[KEY_ESC]) {
             blit(this->ajuda,buffer, 0, 0, 0, 0, MAX_X, MAX_Y);
             blit(buffer, screen, 0, 0, 0, 0, buffer->w, buffer->h); 
            } 
            rest(30);
        } else if (opcaoX == 210) {
			this->credito->printCreditos(screen);
            rest(30);
            //allegro_exit();
            return 0;
        }    
    }

    rest(130);
    }
    stop_sample(som_fundo);

    return 1;
}
    
};
