#ifndef FADE
    #define FADE
#ifndef ALLEGRO
    #define ALLEGRO
    #include <allegro.h>
#endif    
class Fade{
public:
        Fade(){
        }
        ~Fade(){
        }        
    void high_color_fade_in(BITMAP* origem, int velocidade) {
		BITMAP* buff;
		if((buff = create_bitmap(SCREEN_W, SCREEN_H))) {
			int cont;
			if(velocidade <= 0)
				velocidade = 16;
			for(cont = 0;cont < 256; cont = cont + velocidade) {
				clear(buff);
				set_trans_blender(0, 0, 0, cont);
				draw_trans_sprite(buff, origem, 0, 0);
				vsync();
				blit(buff, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
			}
			
			destroy_bitmap(buff);
		}
		blit(origem, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	}

	void high_color_fade_out(int velocidade) {
		BITMAP* origem;
		BITMAP* buff;

		if((origem = create_bitmap(SCREEN_W, SCREEN_H))) {
			if((buff = create_bitmap(SCREEN_W, SCREEN_H))) {
				int cont;
				blit(screen, origem, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
				if(velocidade <= 0)
					velocidade = 16;
				for(cont = 255-velocidade;cont > 0;cont = cont - velocidade) {
					clear(buff);
					set_trans_blender(0, 0, 0, cont);
					draw_trans_sprite(buff, origem, 0, 0);
					vsync();
					blit(buff, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
				}
				destroy_bitmap(buff);
			}
			destroy_bitmap(origem);
		}
		rectfill(screen, 0, 0, SCREEN_W, SCREEN_H, makecol(0, 0, 0));
	}
}*fade;
#endif
