#ifndef LIFE
    #define LIFE
enum ColorLife {BLUE,RED,GREEN};  
class Life{

    //private:
        public:
    //Tamanho do life
     int wLife;
     int hLife;    
    //Tamanho do Background
     int wMod; 
     int hMod; 
	//BackGround
	 BITMAP *backGround; 
     BITMAP *carregando; 
    //Cor do BackGround
     int backGroundColor;
   
    //Posio do Life no BackGround (Depende das Margens)
     int posX1Life;
     int posY1Life;
    //Posio da Extremidade do Life no Background (Depende da largura do Life)
     int posX2Life;     
    //Valor a ser incrementado ou decrementado na cor do degrad
     int varColorDegr;   
    //Posio X e Posio Y da Tela de impreo do Life
     int posX;
     int posY;
    //Quantidade de pixel para incremento ou decremento do life
    int unitLife;
    //Bitmap de destino para impreso do Life
    BITMAP *dest; 
    //rosto do slug no life   
    BITMAP *rostos;       
   
    //Largura das bordas
    int borderLR;
    int borderTD;        
    //cor de base para o degrad Red, Green or Blue
    enum ColorLife colorBase;
    //Cor inicial do degrad do life
    int initColorLife;        
    
    //ponteiro para os rostos
    int ptrRosto;
    //contador de vidas
    int lifes;
    bool lifeEmpty;
    // diz se o texto da quant de vidas vai ser escrito    
    bool printText;
    bool avatarIsVisible;
    //public:
        Life(){
             this->lifeEmpty = false;
             
             this->printText = true;
             
             this->avatarIsVisible = true;
                    
             this->ptrRosto = 0; 
             
             this->lifes = 2;
            
             this->rostos = load_bitmap("images\\rostos.bmp", NULL);
             
             this->carregando = load_bitmap("images\\carregando.bmp", NULL);
            
             this->colorBase = RED;
                          
             this->unitLife = 30;          
                             
             this->wLife = unitLife*3;
             this->hLife = 10;             
             
             this->posX = 10;
             this->posY = 10;
             
             this->borderLR = 1;
             this->borderTD = 1;            
             
             this->wMod = this->wLife+1+(2 * this->borderLR); 
             this->hMod = this->hLife+(2 * this->borderTD); 	
             
             this->posX1Life = this->borderLR;
             this->posY1Life = this->borderTD;
             
             //this->posX2Life = this->posX1Life + this->wLife;        
             this->wLife += this->posX1Life;        
                       
             this->initColorLife = 40;
             this->varColorDegr = 30;
             
             this->backGroundColor = 65535;//makecol(255,255,255);
             this->backGround = create_bitmap(wMod,hMod);
             //this->backGround = create_bitmap(wMod+this->avatar->w,this->avatar->h);
             
             clear_to_color(this->backGround, this->backGroundColor);             
        }
        ~Life(){
        }
       
     void printRoundBorder(){
        putpixel(this->backGround, 0,0,63519);
        putpixel(this->backGround, 0,this->hMod - 1,63519);        
        putpixel(this->backGround,this->wMod-1,0,63519);        
        putpixel(this->backGround,this->wMod-1,this->hMod - 1,63519);                
                
        putpixel(this->backGround, this->posX1Life,this->posY1Life,this->backGroundColor);//+ + 
        putpixel(this->backGround, this->posX1Life,(this->hMod - 1)- this->posY1Life,this->backGroundColor);   // + -        
        putpixel(this->backGround,(this->wMod)-2,1,this->backGroundColor); //- +
        putpixel(this->backGround,(this->wMod)-2,(this->hMod) - 2,this->backGroundColor);// - -
    }
    int ajustLegthLife(){
        return (this->wMod-1)-(this->wLife);
    }    
                    
    void setColorBase(ColorLife baseColor){
        this->colorBase = baseColor;
    }    
    void setWidthLife(int wLife){        
        this->wLife = wLife;
        this->wMod = wLife+(2 * this->borderLR);
        this->backGround = create_bitmap(this->wMod,this->hMod);
        
    }
    void setPrintText(bool setText){
        this->printText = setText;
    }
    void setPrintAvatar(bool avatarVisible){
        this->avatarIsVisible = avatarVisible;
    }
    void setHeightLife(int hLife){
        this->hLife = hLife;
        this->hMod = hLife+(2 * this->borderTD);
        this->backGround = create_bitmap(this->wMod,this->hMod);
    }                
    void setUnitLife(int unitLife){
        if(unitLife > 0){
           this->unitLife = unitLife;
        }    
    }  
    private: 
    void printAvatar(BITMAP *dest, int posX, int posY){
        int perCent = this->wLife*100/this->wMod-2;         
        if(perCent >=66){
            this->ptrRosto = 0;
        }else if(perCent>=33 && perCent<66){
            this->ptrRosto = 1;
        }else if(perCent<33){
            this->ptrRosto = 2;
        }            
        int wFrame = this->rostos->w / 3;//supondo que se tem 3 rostos no sprite
        masked_blit(this->rostos, dest,this->ptrRosto * wFrame,0,posX,posY, wFrame, this->rostos->h);        
    }    
    public:   
    bool lifeIsEmpty(){
        return this->lifeEmpty;
    }
    void reloadLife(){
        if(this->isEmpty()){
         int tempUnit = this->unitLife;
         this->unitLife = 1;
          for(int i = 0; i<90;i++){              
              this->incrLife(1);              
          }
          this->unitLife = tempUnit;    
          if(this->lifes > 0){
              this->lifes--;                    
          }else{
               this->lifeEmpty = true;     
          }    
       } 
    }    
    void printLife(BITMAP *dest, int posX, int posY){
      int color = this->initColorLife;
      int hLife = this->hLife;             
      /*Guardar no objeto o estado atual dele*/
      this->dest = dest;      
      this->posX = posX+this->rostos->w/3+3;
      this->posY = posY;
      /*if(this->isEmpty()){
          for(int i = 0; i<5;i++){
              this->incrLife(1);
          }    
          if(this->lifes > 0){
              this->lifes--;                    
          }else{
               this->lifeEmpty = true;     
          }    
      } */ 
      if(this->printText){            
            textprintf(dest, font, this->posX, this->posY+this->hLife+4, 65535, "x%d",/*this->wLife/this->unitLife*/this->lifes);
      }   
      if(this->avatarIsVisible){             
            printAvatar(dest, posX, posY); 
      }else{
            masked_blit(this->carregando, dest,0,0,this->posX-10,this->posY-this->carregando->h-3, this->carregando->w, this->carregando->h);                   
      }
                      
      clear_to_color(this->backGround, this->backGroundColor);
      if(!this->isEmpty()){
          for(int i=0; i<hLife; i++){          
                color = color + this->varColorDegr;
                if(color%255 < color){    
                        color = 255;
                }            
                switch(this->colorBase){
                  case RED:
                    hline(this->backGround, this->posX1Life, i+this->posY1Life ,  this->wLife, makecol(color,0,0));            
                  break;
                  case GREEN:
                    hline(this->backGround, this->posX1Life, i+this->posY1Life , this->wLife, makecol(0,color,0));              
                  break;
                  case BLUE:
                    hline(this->backGround, this->posX1Life, i+this->posY1Life , this->wLife, makecol(0,0,color));              
                  break;
                }              
           }   
       }        
       this->printRoundBorder();   
       //modifiquei
       masked_blit(this->backGround, dest,0,0,this->posX,this->posY, this->backGround->w, this->backGround->h);       
    }
    
    void setInitDegrLifeColor(int initColorBase255){           
        this->initColorLife = initColorBase255%256;     
    }    
    
    void setBackgroundColor(int color){
        this->backGroundColor = color;
    }    
    void setBackgroundColor_RGB(int r, int g, int b){
        this->backGroundColor = makecol(r%256,g%256,b%256);
    }
    void decrLife(int units){
        int decr = units * this->unitLife;
        if(this->wLife - decr <= 0){
           this->wLife = 1; 
           clear_to_color(this->backGround, this->backGroundColor);
           this->printRoundBorder();
           masked_blit(this->backGround, dest,0,0,posX,posY, this->backGround->w, this->backGround->w);           
        }else{              
            this->wLife -= decr;                      
        }    
    }    
    void incrLife(int units){
        int incr = units * this->unitLife;
        if(this->wLife + incr >= this->wMod-1){
           this->wLife = this->wMod-2;          
        }else{    
           this->wLife += incr;
        }          
    }
    bool isEmpty(){
        if(this->wLife == 1){
          return true;   
        }else{
            return false;
        }        
    }       
};    
#endif
