#ifndef LOADERIMAGES
    #define LOADERIMAGES
#include "animacao.h"

struct Animacoes{
    AnimacaoRotina2 *SLUG_ANDANDO_PISTOLA;
    AnimacaoRotina *SLUG_ANDAR_ATIRANDO;
    AnimacaoAndar *SLUG_ANDANDO_OLHANDO_P_CIMA;
    AnimacaoRotina *SLUG_ATIRANDO_PISTOLA;
    AnimacaoRotina *SLUG_ATIRANDO_PULANDO;
    AnimacaoPular *SLUG_PULANDO;
    AnimacaoRotina *SLUG_BEBENDO_AGUA;
    AnimacaoRotina *SLUG_DORMINDO;
    AnimacaoRotina *SLUG_PARADO;
    AnimacaoRotina2 *SLUG_ABAIXADO;
    AnimacaoRotina *SLUG_ANDANDO_ABAIXADO;
    AnimacaoRotina *SLUG_ATIRANDO_ABAIXADO;
    AnimacaoRotina *SLUG_JOGANDO_BOMBA;
    AnimacaoRotina *SLUG_ATIRANDO_P_BAIXO;
    AnimacaoRotina *PERDER_LIFE;
    AnimacaoRotina2 *SLUG_MIRNADO_P_BAIXO;
    AnimacaoRotina2 *SLUG_OLHANDO_P_CIMA;
    AnimacaoRotina *ATIRANDO_P_CIMA;
    AnimacaoRotina *ANDANDO_ATIRANDO_P_CIMA;
    AnimacaoRotina *PULANDO_JOGANDO_BOMBA;
    AnimacaoRotina *PARADO_JOGANDO_BOMBA;
    AnimacaoRotina *ANDANDO_JOGANDO_BOMBA;
    AnimacaoRotina *MORRENDO;
    AnimacaoRotina *COMEMORANDO;
    AnimacaoRotina *ESFAQUEAR_ABAIXADO;
    
    Animacoes(){     
        SLUG_ANDANDO_PISTOLA = new AnimacaoRotina2(16,4,1,new ParFigura("images\\Slug_Andando_Pistola.bmp"),0,0);
        SLUG_ANDAR_ATIRANDO = new AnimacaoRotina(12,1,new ParFigura("images\\andandoAtirando.bmp"),-25,7);
        SLUG_ANDANDO_OLHANDO_P_CIMA = new AnimacaoAndar(14,4,new ParFigura("images\\AndandoOlhandoCima.bmp"),-2,5);
        SLUG_ATIRANDO_PISTOLA = new AnimacaoRotina(10,1,new ParFigura("images\\Slug_Atirando_Pistola.bmp"),-21,9);
        SLUG_PULANDO = new AnimacaoPular(23,new ParFigura("images\\pulando.bmp"),5,5);
        SLUG_BEBENDO_AGUA = new AnimacaoRotina(23,4,new ParFigura("images\\Slug_Bebendo_Agua.bmp"),0,4);
        SLUG_DORMINDO = new AnimacaoRotina(22,6,new ParFigura("images\\Dormindo.bmp"),1,10);
        SLUG_PARADO = new AnimacaoRotina(5,4,new ParFigura("images\\Slug_Parado.bmp"),-2,10);
        SLUG_ABAIXADO = new AnimacaoRotina2(8,3,4,new ParFigura("images\\Slug_Abaixando2.bmp"),-6,10);
        SLUG_ANDANDO_ABAIXADO = new AnimacaoRotina(6,4,new ParFigura("images\\SlugAndandoAbaixado2.bmp"),-6,10);
        SLUG_ATIRANDO_ABAIXADO = new AnimacaoRotina(8,1,new ParFigura("images\\AtirandoAbx.bmp"),-27,10);
        SLUG_JOGANDO_BOMBA = new AnimacaoRotina(13,1,new ParFigura("images\\jogandoBombaAbx.bmp"),-9,12);
        SLUG_ATIRANDO_PULANDO = new AnimacaoRotina(12,1,new ParFigura("images\\atirandoPuloReto.bmp"),-21,0);
        SLUG_ATIRANDO_P_BAIXO = new AnimacaoRotina(8,2,new ParFigura("images\\Slug_atirando_p_baixo.bmp"),1,5);
        PERDER_LIFE = new AnimacaoRotina(10,2,new ParFigura("images\\perdendoLife.bmp"),-14,11);
        SLUG_OLHANDO_P_CIMA = new AnimacaoRotina2(9,3,2,new ParFigura("images\\olhandoPraCimaParado.bmp"),-3,8);
        SLUG_MIRNADO_P_BAIXO = new AnimacaoRotina2(2,1,6,new ParFigura("images\\pulando_mirando_abaixo.bmp"),2,0);
        ATIRANDO_P_CIMA = new AnimacaoRotina(11,1,new ParFigura("images\\atiradoParadoCima.bmp"),-3,-32);
        ANDANDO_ATIRANDO_P_CIMA = new AnimacaoRotina(18,1,new ParFigura("images\\correndoAtirandoCima.bmp"),-11,-32);
        PULANDO_JOGANDO_BOMBA = new AnimacaoRotina(12,1,new ParFigura("images\\jogandoBombaPuloParado.bmp"),-10,0);
        PARADO_JOGANDO_BOMBA = new AnimacaoRotina(13,1,new ParFigura("images\\AtirandoBombaPe.bmp"),-7,6);
        ANDANDO_JOGANDO_BOMBA = new AnimacaoRotina(13,1,new ParFigura("images\\andandoBomba.bmp"),-8,3);
        MORRENDO = new AnimacaoRotina(17,3,new ParFigura("images\\SlugMorrendo.bmp"),-10,15);
        COMEMORANDO = new AnimacaoRotina(8,2,new ParFigura("images\\Comemorando.bmp"),0,0);
        ESFAQUEAR_ABAIXADO = new AnimacaoRotina(13,1,new ParFigura("images\\facadaAbx.bmp"),-10,14);
    }       
    ~Animacoes(){
       delete(SLUG_ANDANDO_PISTOLA);
       delete(SLUG_ANDAR_ATIRANDO);
       delete(SLUG_ANDANDO_OLHANDO_P_CIMA);
       delete(SLUG_ATIRANDO_PISTOLA);
       delete(SLUG_PULANDO);
       delete(SLUG_BEBENDO_AGUA);
       delete(SLUG_DORMINDO);
       delete(SLUG_PARADO);
       delete(SLUG_ABAIXADO);
       delete(SLUG_ANDANDO_ABAIXADO);
       delete(SLUG_ATIRANDO_ABAIXADO);
       delete(SLUG_JOGANDO_BOMBA);
       delete(SLUG_ATIRANDO_PULANDO);
       delete(SLUG_ATIRANDO_P_BAIXO);
       delete(PERDER_LIFE);
       delete(SLUG_OLHANDO_P_CIMA);
       delete(SLUG_MIRNADO_P_BAIXO);
       delete(ATIRANDO_P_CIMA);
       delete(ANDANDO_ATIRANDO_P_CIMA);
       delete(PULANDO_JOGANDO_BOMBA);
       delete(MORRENDO);
       delete(COMEMORANDO);
       delete(PARADO_JOGANDO_BOMBA);
       delete(ESFAQUEAR_ABAIXADO);
    }    
};    
#endif
