#ifndef COLISAO
    #define COLISAO

#ifndef ALLEGRO
    #define ALLEGRO
    #include <allegro.h>
#endif
#include "animacao.h"

bool pontoRetangulo(int pontoX,int pontoY,Animacao *retangulo,int retX,int retY,bool direita){
    int cor = 0;
	bool retorno = 0;
	bool um = true;
	if(pontosCriticosDeColisoes && ligaDebug)
		rect(buffer,pontoX,pontoY,pontoX,pontoY,63519);
	
	//***********************
	int imprX = retangulo->corrImprX;
	int imprY = retangulo->corrImprY;
	int espace = retangulo->espacamento;
	int pont = retangulo->ponteiro;
	int qtd = retangulo->quantidade;
	BITMAP *figDir = retangulo->figura_direita;
	BITMAP *figEsq = retangulo->figura_esquerda;

	int dir = direita;
	BITMAP *p1 = (direita?retangulo->figura_direita:retangulo->figura_esquerda);
	
	int p3;// = pontoY - (retY + retangulo->corrImprY);
	int p2;// = pontoX-(retX+retangulo->corrImprX)+

	__asm {
		//Verificao 1: (pontoX < (retX + retangulo->corrImprX)
		mov eax, pontoX //armazena o valor de pontoX no registrador eax
		mov ebx, imprX //armazena o valor de imprX no registrador ebx
		add ebx, retX //ebx = ebx + retX => impr + retX
		cmp eax, ebx //compara pontoX (eax) com [impr + retX] (ebx)
		jl returnFalse //se pontoX < [impr + retX], ir para returnFalse

		//Verificao 2: (pontoX > (retX + retangulo->corrImprX + retangulo->espacamento)
		mov ebx, retX 
		add ebx, imprX
		add ebx, espace
		cmp pontoX, ebx
		jg returnFalse
		
		
		//Verificao 3
		mov ecx, pontoY
		sub ecx, retY
		sub ecx, imprY 
		//push ecx //3 paramentro na pilha
		mov p3, ecx //seta o 3 parmetro do mtodo getpixel

		mov ebx, pontoX
		sub ebx, retX
		sub ebx, imprX

		cmp direita, 1h
		je setarParamsDir

		mov edx, qtd
		sub edx, pont
		mov ecx, 1h
		sub edx, ecx
		mov eax, espace
		mul edx
		add ebx, eax
		mov p2, ebx //seta o 2 parmetro do mtodo getpixel
		//push ebx //2 parametro
		
		//mov edx, figEsq
		//push figEsq //1 parametro

		jmp GetPixel  //chama o mtodo getpixel e seta a varivel cor
		
	setarParamsDir:  //seta o parmetro caso a figura esteja pra direita
		mov eax, pont
		mov edx, espace
		mul edx
		add ebx, eax
		mov p2, ebx //seta o 2 parmetro do mtodo getpixel

		jmp GetPixel //seta o parmetro caso a figura esteja pra direita
		//push ebx //2 parametro

		//mov edx, figDir
		//push figDir //1 parametro
/**		
	pegarPixel:
		mov esi, esp
		//push ecx
		//push ebx
		//push edx
		
		call getpixel
		
		add esp, 12
		mov cor, eax
		cmp esi, esp
		je compararCor
		mov esp, esi*/

	compararCor:
		cmp cor, PIXEL_TRANSP
		je returnFalse

	//Verificao 4 : cor == -1
		mov ecx, -1
		cmp cor, ecx
		je returnFalse

	}

	__asm returnTrue:
		return true;

	//__asm jmp fim

	__asm returnFalse:
		return false;

	//__asm fim:

	__asm GetPixel:
		cor = getpixel(p1, p2, p3);
	
	__asm jmp compararCor

	//return retorno;

	//**********************

	/*
    if(pontoX<(retX+retangulo->corrImprX) ||
       pontoX>(retX+retangulo->corrImprX+retangulo->espacamento) ||
        (cor = getpixel((direita?retangulo->figura_direita:retangulo->figura_esquerda),pontoX-(retX+retangulo->corrImprX)+
                      (direita?(retangulo->ponteiro*retangulo->espacamento):(retangulo->quantidade-retangulo->ponteiro -1)*retangulo->espacamento)
                      ,pontoY-(retY+retangulo->corrImprY)))==PIXEL_TRANSP || cor==-1)
        return false;
    else
        return true;
	*/
        
}
#endif


  
