#include <stdio.h>
#include <stdlib.h>
#ifndef ALLEGRO
    #define ALLEGRO
    #include <allegro.h>
#endif
#define MAX_X         320
#define MAX_Y         240
#define V_MAX_X       0
#define V_MAX_Y       0
#define COLOR_BITS    16
#define VIDEO_CARD    AUTODETECT

#define DIGI_CARD     DIGI_AUTODETECT
#define MIDI_CARD     MIDI_AUTODETECT
#define PIXEL_TRANSP  63519  //cdigo das cores especiais em 16 bits
#define PIXEL_P_HORZ  65504
#define PIXEL_P_PARE  31
#define PIXEL_RAMPA   63488
//PRECISAM SER DECLARADAS ANTES PQ SAO VARIAVEIS GLOBAIS E SAO VISTAS POR MUITAS CLASSES INCLUSAS LOGO EM SEGUIDA
int contador;
int posX; //posicao do personagem principal  X
int posY; //posicao do personagem principal  Y
BITMAP *buffer;
bool MORREU;
bool VENCEU;
int stage;

//BOOLEANOS PARA CONTROLE DO DEBBUG
bool ligaDebug , travaQ;
bool matrix , travaW;
bool pontosCriticosDeColisoes , travaE;
bool ponteirosArrays , travaR;
bool imortal , travaT;
//*********************************

#include "principal.h"
#include "animacao.h"
#include "cenario.h"
#include "mover.h"
#include "LoaderImages.h"
#include "grade.h"
#include "Fade.h"
#include "Intro.h"
#include "sounds.h"
#include "Abertura.h"
#include "GameOver.h"
#include "Creditos.h"
#include "Life.h"


void iniciar(){
   allegro_init();
   install_timer();
   install_keyboard();
   if (install_sound(DIGI_CARD, MIDI_CARD, NULL) < 0)	{	
      //  if(install_sound(DIGI_SB, MIDI_ADLIB, NULL) < 0)	
        allegro_exit();        
   } 
   set_color_depth(COLOR_BITS); 
   set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, MAX_X, MAX_Y, V_MAX_X, V_MAX_Y);

   //Configura o volume do SOM	
   text_mode(-1);
   set_volume(170, 170);
   }

int main (void){
    iniciar();
    SAMPLE *som_intro;
    som_intro = load_sample(introducao);
    posX = 150;
    posY = 50;
    contador = 0;
    stage = 1;    
    //int vidas = 2;
    MORREU = false;
    VENCEU = false; 

	ligaDebug = travaQ = false;
	matrix = travaW = false;
	pontosCriticosDeColisoes = travaE = false;
	ponteirosArrays = travaR = false;
	imortal = travaT = false;
	
    long latency;
    int frameRate = 30;

    bool firstVez;
    fade = new Fade();
    intro = new Intro(screen);
    gameOver = new GameOver();
    creditos = new Creditos();
    Life *progressBar = new Life();
    
    progressBar->setColorBase(BLUE);
    progressBar->setHeightLife(20);
    progressBar->setUnitLife(38);
    progressBar->setPrintText(false);
    progressBar->setWidthLife(150);
    progressBar->wLife = 0;
    progressBar->setPrintAvatar(false);
    
    
    
    
    firstVez = true;
    play_sample(som_intro, 255, 128, 1000, 0);
    intro->printIntro();
    delete(intro);
    stop_sample(som_intro);
    
//    progressBar->setBackgroundColor(0);
// clear_to_color(screen, 0);
    fade->high_color_fade_out(10);
    
    SAMPLE *som_fundo;
    som_fundo = load_sample(fundo);     
        progressBar->incrLife(1);
        progressBar->printLife(screen, 50, 110);
    SAMPLE *som_Missao1;
    som_Missao1 = load_sample(missao1);
    SAMPLE *som_Missao2;
    som_Missao2 = load_sample(missao2);
    SAMPLE *som_Missao3;
    som_Missao3 = load_sample(missao3);
        progressBar->incrLife(1);
        progressBar->printLife(screen, 50, 110);
    SAMPLE *som_fundo2;
    som_fundo2 = load_sample(fundo2);
    SAMPLE *som_fundo3;
    som_fundo3 = load_sample(fundo3);
    SAMPLE *som_tiro;
    som_tiro = load_sample(tiro);
    SAMPLE *som_grito_slug;
    som_grito_slug = load_sample(grito_slug);
    
    SAMPLE *som_grito_ini;
    som_grito_ini = load_sample(grito_ini);
   
        progressBar->incrLife(1);
        progressBar->printLife(screen, 50, 110);
    MIDI *som_fundo1;
    som_fundo1 = load_midi(fundo1);
        progressBar->incrLife(1);
        progressBar->printLife(screen, 50, 110);
        rest(1000);
  //  progressBar->setBackgroundColor(65535);        
    
    option:
    buffer = create_bitmap(MAX_X,MAX_Y);
    clear_to_color(buffer,0); 
    Abertura *abertura = new Abertura();
    int opcao = abertura->exibir();
    delete(abertura);
    destroy_bitmap(buffer);
  
    Load_stage:
    
    if(stage==4){
       opcao = 2;
       stage = 1;
    }
   
    switch(opcao){
    
        case 2:
            creditos->printCreditos(screen); 
            goto option;           
            break;
        case 0:  //SAIR
            allegro_exit();
            return 0;
            break;
        case 1:  //JOGAR
            progressBar->wLife = 0;   
            progressBar->setUnitLife(22);
            fade->high_color_fade_out(10);
            cenario = new Cenario(stage);
                 //intercalar com imagens simulando barra de progresso
                     progressBar->incrLife(1);
                     progressBar->printLife(screen, 50, 110);
            Grade *g_r_a_d_e = new Grade(cenario,50);
                     progressBar->incrLife(1);   
                     progressBar->printLife(screen, 50, 110);
                 //intercalar com imagens simulando barra de progresso
            Animacoes* animacoesPrincipal = new Animacoes();
                     progressBar->incrLife(1);              
                     progressBar->printLife(screen, 50, 110);
                 //intercalar com imagens simulando barra de progresso                 
            principal = new Principal(0,0,animacoesPrincipal,cenario,g_r_a_d_e);
                   //intercalar com imagens simulando barra de progresso
                     progressBar->incrLife(1);
                     progressBar->printLife(screen, 50, 110);                     
            bfCenario = new Buffer(cenario, &posX);
                     progressBar->incrLife(1);   
                     progressBar->printLife(screen, 50, 110);                     
            buffer = bfCenario->buffer;
                     progressBar->incrLife(1);   
                     progressBar->printLife(screen, 50, 110);                                            
                     
                   //intercalar com imagens simulando barra de progresso
                    
            switch(stage){
                case 1:
                    stop_sample(som_fundo3);
                    play_sample(som_Missao1, 200, 128, 1000, 0);
                    play_midi(som_fundo1, 1);
                  
                    break;
                case 2:
                    stop_midi();
                    play_sample(som_Missao2, 200, 128, 1000, 0);
                    play_sample(som_fundo2, 250, 128, 1000, 1);
                    
                    break;
                case 3:
                   stop_sample(som_fundo2);
                   play_sample(som_Missao3, 200, 128, 1000, 0);
                   play_sample(som_fundo3, 200, 128, 1000, 1);
                   
                    break;
            }
            while(!MORREU && !key[KEY_ESC] && !VENCEU){
				if(ponteirosArrays)
					text_mode(0);
				else
					text_mode(-1);
				//ANALISE DAS TECLAS DE DEBBUG
				if(!travaQ && key[KEY_Q]){
				    travaQ = true;
					ligaDebug = !ligaDebug;
				}
				if(!key[KEY_Q])
					travaQ = false;
				
				if(!travaW && key[KEY_W]){
				    travaW = true;
					matrix = !matrix;					
				}
				if(!key[KEY_W])
					travaW = false;
				
				if(!travaE && key[KEY_E]){
				    travaE = true;
					pontosCriticosDeColisoes = !pontosCriticosDeColisoes;
				}
				if(!key[KEY_E])
					travaE = false;
				
				if(!travaR && key[KEY_R]){
				    travaR = true;
					ponteirosArrays = !ponteirosArrays;
				}
				if(!key[KEY_R])
					travaR = false;
				
				if(!travaT && key[KEY_T]){
				    travaT = true;
					imortal = !imortal;
				}
				if(!key[KEY_T])
					travaT = false;
				
				//********************************************
                latency = time(NULL);
                bfCenario->printFundo();//funcao que imprime o background no buffer;    
                principal->moverPrincipal();//funcao responsavel por movimentar o personagem principal
                g_r_a_d_e->moverElementos();//funcao responsavel por movimentar os outros personages e objetos animados extras
              //  if(key[KEY_F])
				principal->animar();//funcao responsavel por organizar os estados e imprimir as imagens do personagem principal
                if(firstVez){
                    fade->high_color_fade_in(buffer,5);
                    firstVez = false;
                }
                bfCenario->printFinal();
                latency = time(NULL) - latency;
                if(matrix && ligaDebug)
                    rest(frameRate-latency+250);        
                else
                    rest(frameRate-latency);        
            }
            stop_sample(som_fundo3);
             stop_midi();
             stop_sample(som_fundo2);
            fade->high_color_fade_out(4);
            delete(cenario);
           // delete(g_r_a_d_e);
            delete(animacoesPrincipal);
           // delete(principal);
            delete(bfCenario);
            
            if(VENCEU){
                VENCEU = false;               
                       stage++;                           
            }else if(MORREU){
                MORREU = false;
                gameOver->loadGameOver();
                posX = 150;
                posY = 50;
                firstVez = true;
                goto option;
            //    vidas--;                
            }else{
                goto option;
            }
            break;
        
    }
        
   
    
    posX = 150;
    posY = 50;
    firstVez = true;
    if(!MORREU){
        VENCEU = false;
        goto Load_stage;
    }    
    allegro_exit();
    return 0;
}
END_OF_MAIN();
