#ifndef INTRO
    #define INTRO
#include "animacao.h"    

#ifndef SOUNDS
    #define SOUNDS
    #include "sounds.h"
#endif
class Intro{
    private:   
        SAMPLE *som_come;     
        BITMAP *backGround;
        BITMAP *dest;       
        int wDest;
        int hDest;        
        int velFade;        
        int hIntro;
        int hBorder;
        
        /*ANIMACAO DE FUNDO*/
        int quantidade;
        int espacamento;
        int altura;
        BITMAP *figura_fundo;
        int ponteiro;
        
        Life *progressBar;    
    
    
        
    public:
        Intro(BITMAP *dest){
             this->som_come = load_sample(come_on_boy);
             this->progressBar = new Life();       
             this->progressBar->setColorBase(BLUE);
             this->progressBar->setHeightLife(20);
             this->progressBar->setUnitLife(75);
             this->progressBar->setPrintText(false);
             this->progressBar->setWidthLife(150);
             this->progressBar->wLife = 0;
             this->progressBar->setPrintAvatar(false);   
                
            progressBar->incrLife(1);
            progressBar->printLife(screen, 60, 110);
            figura_fundo = load_bitmap("images\\Intro.bmp", NULL);
            progressBar->incrLife(1);
            progressBar->printLife(screen, 60, 110);
            
            this->ponteiro = 0;
            this->quantidade = 95;
            this->espacamento = (this->figura_fundo->w)/this->quantidade;
            
            this->hIntro = 75;
            this->hBorder = 100 - hIntro;
            this->dest = dest;
            this->wDest = this->dest->w;
            this->hDest = this->dest->h;
            this->backGround = create_bitmap(this->wDest,this->hDest);                
            clear_to_color(this->backGround, makecol(255,255,255));
        }
        ~Intro(){
            destroy_bitmap(this->figura_fundo);
        } 
    void loadImagesForeground(){
        
    } 
    private:
    void printArea(){
        int border = (hDest * hBorder)/200;
        rectfill(this->backGround,0,border,320,hDest-border - 4, 65535);
    }
   /* void anime(int posX, int posY, BITMAP *sprite, int numFrames){
        int espacamento = sprite->w/numFrames;        
        masked_blit(this->sprite,this->backGround, this->ponteiro*espacamento,0,posX,posY, espacamento, this->sprite->h);
        this->ponteiro++;
    }*/                  
    void loadImagesBackground(){
        clear_to_color(this->backGround, 0);
        this->printArea();
        while(this->ponteiro < this->quantidade && !key[KEY_ESC]){  
          if(this->ponteiro == 9){
            play_sample(som_come, 255, 128, 1000, 0);                        
            }                       
            masked_blit(this->figura_fundo,this->backGround, this->ponteiro*this->espacamento,0,8,(hDest * hBorder)/200, this->espacamento, this->figura_fundo->h);            
            blit(this->backGround, this->dest, 0, 0,0,0, this->backGround->w,this->backGround->h);                       
            //textprintf(screen, font, 0, 135, 63519, "EU ENTREI: %d",this->ponteiro);
            rest(70);
            this->ponteiro++;
        }    
        
    }
    void loadIntro(){        
        for(int i=0; i<(hDest * (hBorder/2))/100;i++){                    
            rectfill(this->backGround,0,0,this->backGround->w,i,0);
            rectfill(this->backGround,0,this->backGround->h,this->backGround->w,(this->backGround->h)-i,0);            
            blit(this->backGround, this->dest, 0, 0,0,0, this->backGround->w,this->backGround->h);               
            rest(60);    
        }       
    }
    void unloadIntro(){
        int color = makecol(255,255,255);
        //textprintf(screen, font, 0, 135, 63519, "EU ENTREI: %d",color);
        for(int i=(hDest * (hBorder/2))/100; i>0;i--){            
            rectfill(this->backGround,0,0,this->backGround->w,i,0);
            rectfill(this->backGround,0,this->backGround->h,this->backGround->w,(this->backGround->h)-i,0);               
            blit(this->backGround, this->dest, 0, 0,0,0, this->backGround->w,this->backGround->h);                           
            clear_to_color(this->backGround, color);                     
            rest(60);    
        }
        clear_to_color(this->backGround, color);
        blit(this->backGround, this->dest, 0, 0,0,0, this->backGround->w,this->backGround->h);
    }    
    public:
     void printIntro(){
          this->loadIntro();
          this->loadImagesBackground();
          this->unloadIntro();
     }        
}*intro;
#endif
