  
class Life{
enum ColorLife{BLUE,RED,GREEN};  
    private:
    //Tamanho do life
     int wLife;
     int hLife;
    //Largura das Bordas
     ///////Border *border;    
    //Tamanho do Background
     int wMod; 
     int hMod; 
	//BackGround
	 BITMAP *backGround;    
    //Cor do BackGround
     int backGroundColor;
   
    //Posio do Life no BackGround (Depende das Margens)
     int posX1Life;
     int posY1Life;
    //Posio da Extremidade do Life no Background (Depende da largura do Life)
     int posX2Life;     
    //Valor a ser incrementado ou decrementado na cor do degrad
     int varColorDegr;   
    //Posio X e Posio Y da Tela de impreo do Life
     int posX;
     int posY;
    //Quantidade de pixel para incremento ou decremento do life
    int unitLife;
    //Bitmap de destino para impreso do Life
     BITMAP *dest;
    //Define se a borda do Life vai ser impressa arredondada
    bool roundBorder;
    //Largura das bordas
    int borderLR;
    int borderTD;    
    
    //cor de base para o degrad Red, Green or Blue
    ColorLife colorBase;
    //Cor inicial do degrad do life
    int initColorLife;    
    
    
    
    public:
        Life(){ 
            
             this->colorBase = RED;             
                          
             this->roundBorder = true;              
             
             this->unitLife = 8;          
                             
             this->wLife = unitLife*10;
             this->hLife = 8;             
             
             this->posX = 10;
             this->posY = 10;
             
             this->borderLR = 1;//= this->border->borderLeftRight;
             this->borderTD = 1;//= this->border->borderTopDown;
             
             this->wMod = this->wLife+(2 * this->borderLR); 
             this->hMod = this->hLife+(2 * this->borderTD); 	
             
             this->posX1Life = this->borderLR;
             this->posY1Life = this->borderTD;
             
             this->posX2Life = this->posX1Life + this->wLife;        
                       
             this->initColorLife = 105;//makecol(105,0,0);
             this->varColorDegr = 30;
             
             this->backGroundColor = makecol(255,255,255);
             this->backGround = create_bitmap(wMod+1,hMod);
             
             clear_to_color(this->backGround, this->backGroundColor);             
        }
        ~Life(){
        }
       
    void printRoundBorder(){
        putpixel(this->backGround, 0,0,makecol(255,0,255));
        putpixel(this->backGround, 0,this->hMod - 1,makecol(255,0,255));        
        putpixel(this->backGround,this->wMod,0,makecol(255,0,255));        
        putpixel(this->backGround,this->wMod,this->hMod - 1,makecol(255,0,255));                
        
/*        putpixel(this->backGround, 2,2,makecol(255,255,255));//+ + 
        putpixel(this->backGround, 2,this->hMod - 3,makecol(255,255,255));   // + -
        putpixel(this->backGround,this->wMod-2,2,makecol(255,255,255)); //- +
        putpixel(this->backGround,this->wMod - 2,this->hMod - 3,makecol(255,255,255));// - -
        */
        putpixel(this->backGround, this->posX1Life,this->posY1Life,makecol(255,255,255));//+ + 
        putpixel(this->backGround, this->posX1Life,(this->hMod - 1)- this->posY1Life,makecol(255,255,255));   // + -
        putpixel(this->backGround,(this->wMod)-this->posX1Life,this->posY1Life,makecol(255,255,255)); //- +
        putpixel(this->backGround,(this->wMod)-this->posX1Life,(this->hMod - 1)-this->posY1Life,makecol(255,255,255));// - -
    }
                
   /* private RGB colorToDegrade(){
        //int ret = makecol(this->initColorLife, 0,0);
        RGB rgb = {this->initColorLife,0,0};
        switch(this->colorBase){
            case RED:
               rgb =  {this->initColorLife, 0,0}; 
               break;
            case GREEN:
               rgb =  {0, this->initColorLife,0}; 
               break;
            case BLUE:
               rgb =  {0, 0,this->initColorLife}; 
               break;                              
        }
        return rgb;    
    }*/    
    
    void printLife(BITMAP *dest, int posX, int posY){
      int color = this->initColorLife;
      int hLife = this->hLife; 
     //GB rgb = this->colorToDegrade();
      
      /*Guardar no objeto o estado atual dele*/
      this->dest = dest;
      this->posX = posX;
      this->posY = posY;            
//      textprintf(screen, font, 0, 120, 63519, "posX2Life (Antes de entrar no FOR): %d",this->posX2Life);
      clear_to_color(this->backGround, this->backGroundColor);
      for(int i=0; i<hLife; i++){     
            hline(this->backGround, this->posX1Life, i+this->posY1Life , this->posX2Life, makecol(0,color,0));            
              if((255 - color)<= 0){
                        color = 255;
              }else{
                        color = color + this->varColorDegr;
              }
              
       }       
//       textprintf(screen, font, 0, 140, 63519, "posX2Life (DEPOIS no FOR): %d",this->posX2Life);
       if(roundBorder){
         this->printRoundBorder();   
       }        
       masked_blit(this->backGround, dest,0,0,posX,posY, this->backGround->w, this->backGround->w);       
    }

    /*void debug(){
        textprintf(screen, font, 0, 35, 63519, "wLife: %d",wLife);
        textprintf(screen, font, 0, 45, 63519, "hLife: %d",hLife);
        textprintf(screen, font, 0, 55, 63519, "posX: %d",posX);
        textprintf(screen, font, 0, 65, 63519, "posY: %d",posY);
        textprintf(screen, font, 0, 75, 63519, "back w: %d",this->backGround->w);
        textprintf(screen, font, 0, 85, 63519, "back h: %d",this->backGround->h);
        textprintf(screen, font, 0, 95, 63519, "wMod: %d",wMod);
        textprintf(screen, font, 0, 105, 63519, "hMod: %d",hMod);
        textprintf(screen, font, 0, 115, 63519, "posX1Life: %d",posX1Life);
        textprintf(screen, font, 0, 125, 63519, "posY1Life: %d",posY1Life);
        textprintf(screen, font, 0, 135, 63519, "posX2Life: %d",posX2Life);
        textprintf(screen, font, 0, 145, 63519, "initColorLife: %d",initColorLife);
        textprintf(screen, font, 0, 155, 63519, "varColorDegr: %d",varColorDegr);
        textprintf(screen, font, 0, 165, 63519, "backGroundColor: %d",backGroundColor);        
        
        
    }   */ 
    void setInitLifeColor(int initColorBase, ColorLife colorBase){           
        this->initColorLife = initColorBase%255;
        this->colorBase = colorBase;
    }    
    void setBackgroundColor(int color){
        this->backGroundColor = color;
    }    
    void setBackgroundColor_RGB(int r, int g, int b){
        this->backGroundColor = makecol(r%255,g%255,b%255);
    }
    void decrLife(int units){
        this->posX2Life -= units * this->unitLife;
    }    
    void incrLife(int units){
        this->posX2Life += units * this->unitLife;
    }
    /*bool isEmpty(){
        if(this->){
        }    
    } */   
    
    //Sobrecarga de Operadores 
    /*void operator+=(int incrLife){
        this->wLife += incrLife;
        this->printLife(this->dest,this->posX, this->posY);        
    }    
    void operator-=(int decrLife){
        this->wLife -= decrLife;
        this->printLife(this->dest,this->posX, this->posY);
        
    }
    void operator ++(){
        this->wLife+=this->unitLife;
        this->printLife(this->dest,this->posX, this->posY);        
    }
    void operator --(){
        this->wLife-=this->unitLife;
        this->printLife(this->dest,this->posX, this->posY);        
    }*/            
};    
