#ifndef CENARIO
    #define CENARIO
class Cenario{
public:
    BITMAP *cenario_frente;
    BITMAP *cenario_fundo;
    BITMAP *cenario_restricoes;
    
    Cenario(int stage){
        switch(stage){
            case 1:
                this->cenario_fundo = load_bitmap("images\\Estagio1.bmp",NULL);
                this->cenario_frente = load_bitmap("images\\Foreground1.bmp",NULL);
                this->cenario_restricoes = load_bitmap("images\\Restricoes.bmp",NULL);
                break;
            case 2:
                this->cenario_fundo = load_bitmap("images\\Alemanha.bmp",NULL);
                this->cenario_frente = load_bitmap("images\\foregroundAlemanha.bmp",NULL);
                this->cenario_restricoes = load_bitmap("images\\RestricoesAlemanha.bmp",NULL);
                break;
            case 3:
                this->cenario_fundo = load_bitmap("images\\Iraque.bmp",NULL);
                this->cenario_frente = load_bitmap("images\\foregroundIraque.bmp",NULL);                               
                this->cenario_restricoes = load_bitmap("images\\IraqueR.bmp",NULL);
            break;    
        }
    }    
    ~Cenario(){
        destroy_bitmap(this->cenario_fundo);
        destroy_bitmap(this->cenario_frente);
        destroy_bitmap(this->cenario_restricoes);
    }
    void printFundo(int x){
        blit(this->cenario_fundo,buffer, x, 0, 0, 0, MAX_X, MAX_Y); 
    }
    void printFrente(int x){    
        masked_blit(this->cenario_frente,buffer, x, 0, 0, 0, MAX_X, MAX_Y); 
    }
}*cenario;
class Buffer{
public:
    Cenario *cenario;
    int posReltX; //posicao apartir de onde se est imprimindo;
    int *posX;    //ponteiro para a posicao do boneco;
    BITMAP *buffer;
	BITMAP *debugging;
    
    Buffer(Cenario *cenario,int *posX){
        this->cenario = cenario;
        this->posReltX = 0;
        this->posX = posX;
        buffer = create_bitmap(this->cenario->cenario_frente->w,MAX_Y);        
		debugging = load_bitmap("images\\menuDebug.bmp",NULL);
    }
    ~Buffer(){
        destroy_bitmap(this->buffer);
    }
    void printFundo(){//lembrar de voltar
        blit(this->cenario->cenario_fundo,this->buffer, posReltX-10, 0, posReltX-10, 0,MAX_X+20, MAX_Y);
    }
    void printFinal(){        
        int diferenca = *posX - posReltX;        
        masked_blit(this->cenario->cenario_frente,this->buffer, posReltX-10, 0, posReltX-10, 0,MAX_X+20, MAX_Y);        
        if(diferenca > 120)            
            posReltX += (diferenca - 120)/9;
        else if(diferenca < 80)
            posReltX -= (80 - diferenca)/9;
            //posReltX = *posX - 80;
        if(posReltX<0)
            posReltX = 0;
        else if(posReltX+MAX_X > buffer->w)
            posReltX = buffer->w - MAX_X;
		if(ligaDebug)
			masked_blit(debugging,this->buffer, 0, 0, posReltX+110, 10	,debugging->w, debugging->h);
        blit(this->buffer,screen, posReltX, 0, 0, 0,MAX_X, MAX_Y);
        
    }
}*bfCenario;
#endif
